#! /bin/sh

# ちょちょいとiＣat ＨＴＭＬ生成エンジン
# Chochoito iCat HTML generating engine
# Ver 1.24
# Copyright (C) 2000 by ＳＨＩＮＴＡ (SHINTA)

# Constants and Global Variables

readonly FOOTER_FNAME="Footer.txt"
readonly HEADER_FNAME="Header.txt"
readonly OUT_FNAME="${1}"

Cols=1
ImgHeight=-1
ImgWidth=-1

# Functions

function AnaOption()
# 引数の解析
{
	while [ "${1}" ]
	do
		if [ "${1:0:1}" == "-" ]
		then
			case ${1:1:1} in
			C|c)	#サムネイルの列数
				Cols=`echo ${1} | cut -c3-`
				;;
			H|h)	#サムネイルの高さ
				ImgHeight=`echo ${1} | cut -c3-`
				;;
			W|w)	#サムネイルの横幅
				ImgWidth=`echo ${1} | cut -c3-`
				;;
			*)
				;;
			esac
		fi
		shift
	done
}

function ChkOption()
# 引数が足りているかチェック
{
	if [ ${#} -lt 2 ] || [ "${1:0:1}" == "-" ] || [ "${2:0:1}" == "-" ]
	then
		echo "使用方法："
		echo "	CiCat.sh <出力先> <画像があるフォルダ>... [<オプション>...]"
		echo "オプション（大文字でも小文字でも受け付けます）："
		echo "	-C<列数> (Col Count) : サムネイルの列数"
		echo "	-H<高さ> (Height) : サムネイルの高さ"
		echo "	-W<幅> (Width) : サムネイルの幅"
		echo "使用例："
		echo "	CiCat.sh ~/Catalog.htm /boot/home/screenshots -W100"
		echo "	CiCat.sh ~/Catalog.htm /boot/home/images -H50 -W50 -C5"
		exit
	fi
}

function PrintCtt()
# サムネイル部分を表示
{
	ColCnt=0
	while [ "${2}" != "" ] && [ "${2:0:1}" != "-" ]
	do
		for FPFName in "${2}"/*.[jJ][pP]*[gG] "${2}"/*.[gG][iI][fF] "${2}"/*.[pP][nN][gG]
		do
			if [ ! -f "${FPFName}" ]
			then
				echo "Not Exists ${FPFName}"
				continue
			fi
			let ColCnt+=1
			LineTxt='<A HREF="'"${FPFName}"'" TARGET="_new"><IMG SRC="'"${FPFName}"'" BORDER="0"'
			if [ ${ImgHeight} -ne -1 ]
			then	#サムネイルの高さが指定されている
				LineTxt=' '"${LineTxt}"' HEIGHT="'"${ImgHeight}"'"'
			fi
			if [ ${ImgWidth} -ne -1 ]
			then	#サムネイルの横幅が指定されている
				LineTxt=' '"${LineTxt}"' WIDTH="'"${ImgWidth}"'"'
			fi
			LineTxt="${LineTxt}"'></A>'
			if [ ${ColCnt} -eq ${Cols} ]
			then
				ColCnt=0
				LineTxt="${LineTxt}"'<BR>'
			fi
			echo ${LineTxt} >> "${OUT_FNAME}"
		done
		shift
	done
}

function PrintFooter()
# フッタを表示
{
	FPFooterFName=`dirname ${0}`"/${FOOTER_FNAME}"
	cat ${FPFooterFName} >> "${OUT_FNAME}"
}

function PrintHeader()
# ヘッダを表示
{
	FPHeaderFName=`dirname ${0}`"/${HEADER_FNAME}"
	cat ${FPHeaderFName} > "${OUT_FNAME}"
}

# Program Start
# メインルーチン

ChkOption "$@"
AnaOption "$@"
PrintHeader "$@"
PrintCtt "$@"
PrintFooter "$@"
mimeset -f "${OUT_FNAME}"
